
<h1>Report</h1>

<%= form_tag({:action=>'index'}, :method=>:get, :id=>'controller_filter') do %>
    <p>
     <%= select_tag 'timeframe', options_for_select(@timeframes, @timeframe) , prompt: '-- Time Frame --' %>
     <%= select_tag 'portfolio', options_from_collection_for_select(@portfolios, :id, :name, @portfolio) , prompt: '-- All Portfolios --' %>
     <%= submit_tag 'Run Report' %>
    </p>
<% end %>

<div id='report_statistic_summary'>
  <ul>
    <% if  @realized_gain >=0 then %>
        <li class="profit">Realized Profit: <em><%= smr_humanize @realized_gain, :shortword=>true %></em></li>
    <% else %>
        <li class="loss">Realized Loss: <em><%= smr_humanize @realized_gain, :shortword=>true %></em></li>
    <% end %>
    <li>Revenue:            <em><%= smr_humanize @revenue, :shortword=>true  %></em></li>
  </ul>
</div>

<h2>Asset Development</h2>
<table id='asset_totals'>
  <thead>
    <tr>
        <th></th>
        <th>Invested</th>
        <th>Market Value</th>
        <th>Profit / Loss</th>
    </tr>
  </thead>
  <tbody>
  <%
    this_market_value = 0
    prev_market_value = 0

  @asset_totals.each do |t|
    this_market_value = t.market_value
    prev_market_value = this_market_value if prev_market_value == 0
    change = percentage_change(prev_market_value, this_market_value) || '-'
  %>
    <tr class="separaterows">
      <td>
        <%= link_to '+', asset_index_path %>
        <%= smr_humanize t.date, :time_for_humans=>true %>
      </td>
      <td><%= smr_humanize t.invested, :shortword=>true %></td>
      <td>
        <%= smr_humanize this_market_value, :shortword=>true %>
        <span class="<%= if change.length == 1 then ''
                       elsif change.length>2 and change.starts_with?'-' then 'loss'
                       else 'profit' end %>">
          <%= change %>
        </span>
      </td>
      <td class="<%= smr_profitloss_status t.profit_loss, :css=>true %>">
         <%= smr_humanize t.profit_loss, :shortword=>true %>
      </td>
    </tr>
  <%
    prev_market_value = this_market_value
  end
  %>
  </tbody>
</table>

<% unless @closed_positions.empty? %>
<h2>Closed Positions</h2>
<table id='closed_positions'>
  <thead>
    <tr>
        <th></th>
        <th>Sold At</th>
        <th>Purchase Volume</th>
        <th>Settled Volume</th>
        <th>Charges Paid</th>
        <th>Dividend / Interest Received</th>
        <th>Gain</th>
    </tr>
  </thead>
  <tbody>
  <% @closed_positions.each do |p| %>
    <tr class="separaterows">
      <td>
        <%= link_to '+', p.link.to_url %> <%= p.security %>
        <span>
           <span class="symbol"><%=p.security.symbol%></span>
        </span>
        <% if not p.comment.blank? %><span class="comment_text"><%= 'at %s:' % p.portfolio if p.is_cash_position? %> <%= p.comment %></span><% end %>
      </td>
      <td><%= smr_humanize p.time_closed %></td>
      <td><%= smr_humanize p.purchase_volume %></td>
      <td><%= smr_humanize p.settled_volume %></td>
      <td>
        <%= smr_humanize p.charges %>
        <% if p.charges > 0 %><span><%= smr_humanize p.charges_per_kilo, :scale=>2 %>per 1k</span><% end %>
      </td>
      <td><%= smr_humanize p.dividend.received %></td>
      <td class="<%= smr_profitloss_status p.profit_loss, :css=>true %>">
        <%= smr_humanize p.gain %>
        <span><%= percentage_of(p.purchase_volume, p.gain) %></span>
      </td>
    </tr>
  <% end %>
  </tbody>
</table>
<% end %>
